Loading...
Searching...
No Matches
pcl::SACSegmentation< PointT > Class Template Reference
Module segmentation

SACSegmentation represents the Nodelet segmentation class for Sample Consensus methods and models, in the sense that it just creates a Nodelet wrapper for generic-purpose SAC-based segmentation. More...

`#include <pcl/segmentation/sac_segmentation.h>`

Inheritance diagram for pcl::SACSegmentation< PointT >:

## Public Types

using | PointCloud = pcl::PointCloud<PointT>
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | SearchPtr = typename pcl::search::Search<PointT>::Ptr
using | SampleConsensusPtr = typename SampleConsensus<PointT>::Ptr
using | SampleConsensusModelPtr = typename SampleConsensusModel<PointT>::Ptr
Public Types inherited from pcl::PCLBase< PointT >
using | PointCloud = pcl::PointCloud<PointT>
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| SACSegmentation (bool random=false)
| Empty constructor.
| ~SACSegmentation () override=default
| Empty destructor.
void | setModelType (int model)
| The type of model to use (user given parameter).
int | getModelType () const
| Get the type of SAC model used.
SampleConsensusPtr | getMethod () const
| Get a pointer to the SAC method used.
SampleConsensusModelPtr | getModel () const
| Get a pointer to the SAC model used.
void | setMethodType (int method)
| The type of sample consensus method to use (user given parameter).
int | getMethodType () const
| Get the type of sample consensus method used.
void | setDistanceThreshold (double threshold)
| Distance to the model threshold (user given parameter).
double | getDistanceThreshold () const
| Get the distance to the model threshold.
void | setMaxIterations (int max_iterations)
| Set the maximum number of iterations before giving up.
int | getMaxIterations () const
| Get maximum number of iterations before giving up.
void | setProbability (double probability)
| Set the probability of choosing at least one sample free from outliers.
double | getProbability () const
| Get the probability of choosing at least one sample free from outliers.
void | setNumberOfThreads (const int nr_threads=-1)
| Set the number of threads to use or turn off parallelization.
void | setOptimizeCoefficients (bool optimize)
| Set to true if a coefficient refinement is required.
bool | getOptimizeCoefficients () const
| Get the coefficient refinement internal flag.
void | setRadiusLimits (const double &min_radius, const double &max_radius)
| Set the minimum and maximum allowable radius limits for the model (applicable to models that estimate a radius).
void | getRadiusLimits (double &min_radius, double &max_radius)
| Get the minimum and maximum allowable radius limits for the model as set by the user.
void | setSamplesMaxDist (const double &radius, SearchPtr search)
| Set the maximum distance allowed when drawing random samples.
void | getSamplesMaxDist (double &radius)
| Get maximum distance allowed when drawing random samples.
void | setAxis (const Eigen::Vector3f &ax)
| Set the axis along which we need to search for a model perpendicular to.
Eigen::Vector3f | getAxis () const
| Get the axis along which we need to search for a model perpendicular to.
void | setEpsAngle (double ea)
| Set the angle epsilon (delta) threshold.
double | getEpsAngle () const
| Get the epsilon (delta) model angle threshold in radians.
virtual void | segment (PointIndices &inliers, ModelCoefficients &model_coefficients)
| Base method for segmentation of a model in a PointCloud given by <setInputCloud (), setIndices ()>.
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

virtual bool | initSACModel (const int model_type)
| Initialize the Sample Consensus model and set its parameters.
virtual void | initSAC (const int method_type)
| Initialize the Sample Consensus method and set its parameters.
virtual std::string | getClassName () const
| Class get name method.
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Protected Attributes

SampleConsensusModelPtr | model_ {nullptr}
| The model that needs to be segmented.
SampleConsensusPtr | sac_ {nullptr}
| The sample consensus segmentation method.
int | model_type_ {-1}
| The type of model to use (user given parameter).
int | method_type_ {0}
| The type of sample consensus method to use (user given parameter).
double | threshold_ {0.0}
| Distance to the model threshold (user given parameter).
bool | optimize_coefficients_ {true}
| Set to true if a coefficient refinement is required.
double | radius_min_ {-std::numeric_limits<double>::max()}
| The minimum and maximum radius limits for the model.
double | radius_max_ {std::numeric_limits<double>::max()}
double | samples_radius_ {0.0}
| The maximum distance of subsequent samples from the first (radius search).
SearchPtr | samples_radius_search_ {nullptr}
| The search object for picking subsequent samples using radius search.
double | eps_angle_ {0.0}
| The maximum allowed difference between the model normal and the given axis.
Eigen::Vector3f | axis_ {Eigen::Vector3f::Zero()}
| The axis along which we need to search for a model perpendicular to.
int | max_iterations_ {50}
| Maximum number of iterations before giving up (user given parameter).
int | threads_ {-1}
| The number of threads the scheduler should use, or a negative number if no parallelization is wanted.
double | probability_ {0.99}
| Desired probability of choosing at least one sample free from outliers (user given parameter).
bool | random_
| Set to true if we need a random seed.
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointT>
class pcl::SACSegmentation< PointT >

SACSegmentation represents the Nodelet segmentation class for Sample Consensus methods and models, in the sense that it just creates a Nodelet wrapper for generic-purpose SAC-based segmentation.

Author
  Radu Bogdan Rusu

Definition at line 64 of file sac_segmentation.h.

## Member Typedef Documentation

## PointCloud

template<typename PointT>

using pcl::SACSegmentation< PointT >::PointCloud = pcl::PointCloud<PointT>

Definition at line 73 of file sac_segmentation.h.

## PointCloudConstPtr

template<typename PointT>

using pcl::SACSegmentation< PointT >::PointCloudConstPtr = typename PointCloud::ConstPtr

Definition at line 75 of file sac_segmentation.h.

## PointCloudPtr

template<typename PointT>

using pcl::SACSegmentation< PointT >::PointCloudPtr = typename PointCloud::Ptr

Definition at line 74 of file sac_segmentation.h.

## SampleConsensusModelPtr

template<typename PointT>

using pcl::SACSegmentation< PointT >::SampleConsensusModelPtr = typename SampleConsensusModel<PointT>::Ptr

Definition at line 79 of file sac_segmentation.h.

## SampleConsensusPtr

template<typename PointT>

using pcl::SACSegmentation< PointT >::SampleConsensusPtr = typename SampleConsensus<PointT>::Ptr

Definition at line 78 of file sac_segmentation.h.

## SearchPtr

template<typename PointT>

using pcl::SACSegmentation< PointT >::SearchPtr = typename pcl::search::Search<PointT>::Ptr

Definition at line 76 of file sac_segmentation.h.

## Constructor & Destructor Documentation

## SACSegmentation()

template<typename PointT>

pcl::SACSegmentation< PointT >::SACSegmentation | ( | bool | random = false | ) |

inline

Empty constructor.

Parameters

  [in] | random | if true set the random seed to the current time, else set to 12345 (default: false)

Definition at line 84 of file sac_segmentation.h.

References random_.

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::SACSegmentationFromNormals().

## ~SACSegmentation()

template<typename PointT>

pcl::SACSegmentation< PointT >::~SACSegmentation | ( |  | ) |

override default

Empty destructor.

## Member Function Documentation

## getAxis()

template<typename PointT>

Eigen::Vector3f pcl::SACSegmentation< PointT >::getAxis | ( |  | ) | const

inline

Get the axis along which we need to search for a model perpendicular to.

Definition at line 218 of file sac_segmentation.h.

References axis_.

## getClassName()

template<typename PointT>

virtual std::string pcl::SACSegmentation< PointT >::getClassName | ( |  | ) | const

inline protected virtual

Class get name method.

Reimplemented in pcl::SACSegmentationFromNormals< PointT, PointNT >.

Definition at line 297 of file sac_segmentation.h.

Referenced by initSAC(), initSACModel(), and segment().

## getDistanceThreshold()

template<typename PointT>

double pcl::SACSegmentation< PointT >::getDistanceThreshold | ( |  | ) | const

inline

Get the distance to the model threshold.

Definition at line 127 of file sac_segmentation.h.

References threshold_.

## getEpsAngle()

template<typename PointT>

double pcl::SACSegmentation< PointT >::getEpsAngle | ( |  | ) | const

inline

Get the epsilon (delta) model angle threshold in radians.

Definition at line 228 of file sac_segmentation.h.

References eps_angle_.

## getMaxIterations()

template<typename PointT>

int pcl::SACSegmentation< PointT >::getMaxIterations | ( |  | ) | const

inline

Get maximum number of iterations before giving up.

Definition at line 137 of file sac_segmentation.h.

References max_iterations_.

## getMethod()

template<typename PointT>

SampleConsensusPtr pcl::SACSegmentation< PointT >::getMethod | ( |  | ) | const

inline

Get a pointer to the SAC method used.

Definition at line 103 of file sac_segmentation.h.

References sac_.

## getMethodType()

template<typename PointT>

int pcl::SACSegmentation< PointT >::getMethodType | ( |  | ) | const

inline

Get the type of sample consensus method used.

Definition at line 117 of file sac_segmentation.h.

References method_type_.

## getModel()

template<typename PointT>

SampleConsensusModelPtr pcl::SACSegmentation< PointT >::getModel | ( |  | ) | const

inline

Get a pointer to the SAC model used.

Definition at line 107 of file sac_segmentation.h.

References model_.

## getModelType()

template<typename PointT>

int pcl::SACSegmentation< PointT >::getModelType | ( |  | ) | const

inline

Get the type of SAC model used.

Definition at line 99 of file sac_segmentation.h.

References model_type_.

## getOptimizeCoefficients()

template<typename PointT>

bool pcl::SACSegmentation< PointT >::getOptimizeCoefficients | ( |  | ) | const

inline

Get the coefficient refinement internal flag.

Definition at line 164 of file sac_segmentation.h.

References optimize_coefficients_.

## getProbability()

template<typename PointT>

double pcl::SACSegmentation< PointT >::getProbability | ( |  | ) | const

inline

Get the probability of choosing at least one sample free from outliers.

Definition at line 147 of file sac_segmentation.h.

References probability_.

## getRadiusLimits()

template<typename PointT>

void pcl::SACSegmentation< PointT >::getRadiusLimits | ( | double & | min_radius,
|  | double & | max_radius )

inline

Get the minimum and maximum allowable radius limits for the model as set by the user.

Parameters

  [out] | min_radius | the resultant minimum radius model
  [out] | max_radius | the resultant maximum radius model

Definition at line 183 of file sac_segmentation.h.

References radius_max_, and radius_min_.

## getSamplesMaxDist()

template<typename PointT>

void pcl::SACSegmentation< PointT >::getSamplesMaxDist | ( | double & | radius | ) |

inline

Get maximum distance allowed when drawing random samples.

Parameters

  [out] | radius | the maximum distance (L2 norm)

Definition at line 205 of file sac_segmentation.h.

References samples_radius_.

## initSAC()

template<typename PointT>

void pcl::SACSegmentation< PointT >::initSAC | ( | const int | method_type | ) |

protected virtual

Initialize the Sample Consensus method and set its parameters.

Parameters

  [in] | method_type | the type of SAC method to be used

Definition at line 297 of file sac_segmentation.hpp.

References getClassName(), max_iterations_, model_, probability_, sac_, pcl::SAC_LMEDS, pcl::SAC_MLESAC, pcl::SAC_MSAC, pcl::SAC_PROSAC, pcl::SAC_RANSAC, pcl::SAC_RMSAC, pcl::SAC_RRANSAC, samples_radius_, samples_radius_search_, threads_, and threshold_.

Referenced by segment().

## initSACModel()

template<typename PointT>

bool pcl::SACSegmentation< PointT >::initSACModel | ( | const int | model_type | ) |

protected virtual

Initialize the Sample Consensus model and set its parameters.

Parameters

  [in] | model_type | the type of SAC model that is to be used

Reimplemented in pcl::SACSegmentationFromNormals< PointT, PointNT >.

Definition at line 137 of file sac_segmentation.hpp.

References axis_, eps_angle_, pcl::SampleConsensusModelParallelLine< PointT >::getAxis(), pcl::SampleConsensusModelParallelPlane< PointT >::getAxis(), pcl::SampleConsensusModelPerpendicularPlane< PointT >::getAxis(), getClassName(), pcl::SampleConsensusModelParallelLine< PointT >::getEpsAngle(), pcl::SampleConsensusModelParallelPlane< PointT >::getEpsAngle(), pcl::SampleConsensusModelPerpendicularPlane< PointT >::getEpsAngle(), pcl::SampleConsensusModel< PointT >::getRadiusLimits(), pcl::PCLBase< PointT >::indices_, pcl::PCLBase< PointT >::input_, M_PI, model_, radius_max_, radius_min_, random_, pcl::SACMODEL_CIRCLE2D, pcl::SACMODEL_CIRCLE3D, pcl::SACMODEL_CONE, pcl::SACMODEL_CYLINDER, pcl::SACMODEL_ELLIPSE3D, pcl::SACMODEL_LINE, pcl::SACMODEL_NORMAL_PARALLEL_PLANE, pcl::SACMODEL_NORMAL_PLANE, pcl::SACMODEL_NORMAL_SPHERE, pcl::SACMODEL_PARALLEL_LINE, pcl::SACMODEL_PARALLEL_PLANE, pcl::SACMODEL_PERPENDICULAR_PLANE, pcl::SACMODEL_PLANE, pcl::SACMODEL_SPHERE, pcl::SACMODEL_STICK, pcl::SampleConsensusModelParallelLine< PointT >::setAxis(), pcl::SampleConsensusModelParallelPlane< PointT >::setAxis(), pcl::SampleConsensusModelPerpendicularPlane< PointT >::setAxis(), pcl::SampleConsensusModelParallelLine< PointT >::setEpsAngle(), pcl::SampleConsensusModelParallelPlane< PointT >::setEpsAngle(), pcl::SampleConsensusModelPerpendicularPlane< PointT >::setEpsAngle(), and pcl::SampleConsensusModel< PointT >::setRadiusLimits().

Referenced by pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel(), and segment().

## segment()

template<typename PointT>

void pcl::SACSegmentation< PointT >::segment | ( | PointIndices & | inliers,
|  | ModelCoefficients & | model_coefficients )

virtual

Base method for segmentation of a model in a PointCloud given by <setInputCloud (), setIndices ()>.

Parameters

  [out] | inliers | the resultant point indices that support the model found (inliers)
  [out] | model_coefficients | the resultant model coefficients

Definition at line 80 of file sac_segmentation.hpp.

References pcl::PCLBase< PointT >::deinitCompute(), getClassName(), pcl::ModelCoefficients::header, pcl::PointIndices::header, pcl::PointIndices::indices, pcl::PCLBase< PointT >::initCompute(), initSAC(), initSACModel(), pcl::PCLBase< PointT >::input_, method_type_, model_, model_type_, optimize_coefficients_, sac_, threshold_, and pcl::ModelCoefficients::values.

## setAxis()

template<typename PointT>

void pcl::SACSegmentation< PointT >::setAxis | ( | const Eigen::Vector3f & | ax | ) |

inline

Set the axis along which we need to search for a model perpendicular to.

Parameters

  [in] | ax | the axis along which we need to search for a model perpendicular to

Definition at line 214 of file sac_segmentation.h.

References axis_.

## setDistanceThreshold()

template<typename PointT>

void pcl::SACSegmentation< PointT >::setDistanceThreshold | ( | double | threshold | ) |

inline

Distance to the model threshold (user given parameter).

Parameters

  [in] | threshold | the distance threshold to use

Definition at line 123 of file sac_segmentation.h.

References threshold_.

## setEpsAngle()

template<typename PointT>

void pcl::SACSegmentation< PointT >::setEpsAngle | ( | double | ea | ) |

inline

Set the angle epsilon (delta) threshold.

Parameters

  [in] | ea | the maximum allowed difference between the model normal and the given axis in radians.

Definition at line 224 of file sac_segmentation.h.

References eps_angle_.

## setMaxIterations()

template<typename PointT>

void pcl::SACSegmentation< PointT >::setMaxIterations | ( | int | max_iterations | ) |

inline

Set the maximum number of iterations before giving up.

Parameters

  [in] | max_iterations | the maximum number of iterations the sample consensus method will run

Definition at line 133 of file sac_segmentation.h.

References max_iterations_.

## setMethodType()

template<typename PointT>

void pcl::SACSegmentation< PointT >::setMethodType | ( | int | method | ) |

inline

The type of sample consensus method to use (user given parameter).

Parameters

  [in] | method | the method type (check method_types.h)

Definition at line 113 of file sac_segmentation.h.

References method_type_.

## setModelType()

template<typename PointT>

void pcl::SACSegmentation< PointT >::setModelType | ( | int | model | ) |

inline

The type of model to use (user given parameter).

Parameters

  [in] | model | the model type (check model_types.h)

Definition at line 95 of file sac_segmentation.h.

References model_type_.

## setNumberOfThreads()

template<typename PointT>

void pcl::SACSegmentation< PointT >::setNumberOfThreads | ( | const int | nr_threads = -1 | ) |

inline

Set the number of threads to use or turn off parallelization.

Parameters

  [in] | nr_threads | the number of hardware threads to use (0 sets the value automatically, a negative number turns parallelization off)

Note
  Not all SAC methods have a parallel implementation. Some will ignore this setting.

Definition at line 154 of file sac_segmentation.h.

References threads_.

## setOptimizeCoefficients()

template<typename PointT>

void pcl::SACSegmentation< PointT >::setOptimizeCoefficients | ( | bool | optimize | ) |

inline

Set to true if a coefficient refinement is required.

Parameters

  [in] | optimize | true for enabling model coefficient refinement, false otherwise

Definition at line 160 of file sac_segmentation.h.

References optimize_coefficients_.

## setProbability()

template<typename PointT>

void pcl::SACSegmentation< PointT >::setProbability | ( | double | probability | ) |

inline

Set the probability of choosing at least one sample free from outliers.

Parameters

  [in] | probability | the model fitting probability

Definition at line 143 of file sac_segmentation.h.

References probability_.

## setRadiusLimits()

template<typename PointT>

void pcl::SACSegmentation< PointT >::setRadiusLimits | ( | const double & | min_radius,
|  | const double & | max_radius )

inline

Set the minimum and maximum allowable radius limits for the model (applicable to models that estimate a radius).

Parameters

  [in] | min_radius | the minimum radius model
  [in] | max_radius | the maximum radius model

Definition at line 172 of file sac_segmentation.h.

References radius_max_, and radius_min_.

## setSamplesMaxDist()

template<typename PointT>

void pcl::SACSegmentation< PointT >::setSamplesMaxDist | ( | const double & | radius,
|  | SearchPtr | search )

inline

Set the maximum distance allowed when drawing random samples.

Parameters

  [in] | radius | the maximum distance (L2 norm)
  | search |

Definition at line 194 of file sac_segmentation.h.

References samples_radius_, and samples_radius_search_.

## Member Data Documentation

## axis_

template<typename PointT>

Eigen::Vector3f pcl::SACSegmentation< PointT >::axis_ {Eigen::Vector3f::Zero()}

protected

The axis along which we need to search for a model perpendicular to.

Definition at line 281 of file sac_segmentation.h.

Referenced by getAxis(), initSACModel(), pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel(), and setAxis().

## eps_angle_

template<typename PointT>

double pcl::SACSegmentation< PointT >::eps_angle_ {0.0}

protected

The maximum allowed difference between the model normal and the given axis.

Definition at line 278 of file sac_segmentation.h.

Referenced by getEpsAngle(), initSACModel(), pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel(), and setEpsAngle().

## max_iterations_

template<typename PointT>

int pcl::SACSegmentation< PointT >::max_iterations_ {50}

protected

Maximum number of iterations before giving up (user given parameter).

Definition at line 284 of file sac_segmentation.h.

Referenced by getMaxIterations(), initSAC(), and setMaxIterations().

## method_type_

template<typename PointT>

int pcl::SACSegmentation< PointT >::method_type_ {0}

protected

The type of sample consensus method to use (user given parameter).

Definition at line 260 of file sac_segmentation.h.

Referenced by getMethodType(), segment(), and setMethodType().

## model_

template<typename PointT>

SampleConsensusModelPtr pcl::SACSegmentation< PointT >::model_ {nullptr}

protected

The model that needs to be segmented.

Definition at line 251 of file sac_segmentation.h.

Referenced by getModel(), initSAC(), initSACModel(), pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel(), and segment().

## model_type_

template<typename PointT>

int pcl::SACSegmentation< PointT >::model_type_ {-1}

protected

The type of model to use (user given parameter).

Definition at line 257 of file sac_segmentation.h.

Referenced by getModelType(), segment(), and setModelType().

## optimize_coefficients_

template<typename PointT>

bool pcl::SACSegmentation< PointT >::optimize_coefficients_ {true}

protected

Set to true if a coefficient refinement is required.

Definition at line 266 of file sac_segmentation.h.

Referenced by getOptimizeCoefficients(), segment(), and setOptimizeCoefficients().

## probability_

template<typename PointT>

double pcl::SACSegmentation< PointT >::probability_ {0.99}

protected

Desired probability of choosing at least one sample free from outliers (user given parameter).

Definition at line 290 of file sac_segmentation.h.

Referenced by getProbability(), initSAC(), and setProbability().

## radius_max_

template<typename PointT>

double pcl::SACSegmentation< PointT >::radius_max_ {std::numeric_limits<double>::max()}

protected

Definition at line 269 of file sac_segmentation.h.

Referenced by getRadiusLimits(), initSACModel(), pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel(), and setRadiusLimits().

## radius_min_

template<typename PointT>

double pcl::SACSegmentation< PointT >::radius_min_ {-std::numeric_limits<double>::max()}

protected

The minimum and maximum radius limits for the model.

Applicable to all models that estimate a radius.

Definition at line 269 of file sac_segmentation.h.

Referenced by getRadiusLimits(), initSACModel(), pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel(), and setRadiusLimits().

## random_

template<typename PointT>

bool pcl::SACSegmentation< PointT >::random_

protected

Set to true if we need a random seed.

Definition at line 293 of file sac_segmentation.h.

Referenced by initSACModel(), pcl::SACSegmentationFromNormals< PointT, PointNT >::initSACModel(), and SACSegmentation().

## sac_

template<typename PointT>

SampleConsensusPtr pcl::SACSegmentation< PointT >::sac_ {nullptr}

protected

The sample consensus segmentation method.

Definition at line 254 of file sac_segmentation.h.

Referenced by getMethod(), initSAC(), and segment().

## samples_radius_

template<typename PointT>

double pcl::SACSegmentation< PointT >::samples_radius_ {0.0}

protected

The maximum distance of subsequent samples from the first (radius search).

Definition at line 272 of file sac_segmentation.h.

Referenced by getSamplesMaxDist(), initSAC(), and setSamplesMaxDist().

## samples_radius_search_

template<typename PointT>

SearchPtr pcl::SACSegmentation< PointT >::samples_radius_search_ {nullptr}

protected

The search object for picking subsequent samples using radius search.

Definition at line 275 of file sac_segmentation.h.

Referenced by initSAC(), and setSamplesMaxDist().

## threads_

template<typename PointT>

int pcl::SACSegmentation< PointT >::threads_ {-1}

protected

The number of threads the scheduler should use, or a negative number if no parallelization is wanted.

Definition at line 287 of file sac_segmentation.h.

Referenced by initSAC(), and setNumberOfThreads().

## threshold_

template<typename PointT>

double pcl::SACSegmentation< PointT >::threshold_ {0.0}

protected

Distance to the model threshold (user given parameter).

Definition at line 263 of file sac_segmentation.h.

Referenced by getDistanceThreshold(), initSAC(), segment(), and setDistanceThreshold().

The documentation for this class was generated from the following files:

- pcl/segmentation/sac_segmentation.h
- pcl/segmentation/impl/sac_segmentation.hpp